Index: tests/regressiontests/localflavor/in_/__init__.py
===================================================================
Index: tests/regressiontests/localflavor/in_/tests.py
===================================================================
--- tests/regressiontests/localflavor/in_/tests.py	(revision 0)
+++ tests/regressiontests/localflavor/in_/tests.py	(revision 0)
@@ -0,0 +1,18 @@
+from django.test import TestCase
+from forms import IndiaForm
+
+class IndiaLocalflavorTests(TestCase):
+    def test_state_field_should_normalize_entry_to_two_letter_abbr(self):
+        form = IndiaForm({'state': 'tamilnad'})
+        result = form.is_valid()
+        self.assertTrue(result)
+    
+    def test_should_normalize_two_letter_abbr(self):
+        form = IndiaForm({'state': 'gj'})
+        result = form.is_valid()
+        self.assertTrue(result)
+    
+    def test_should_normalize_state_name(self):
+        form = IndiaForm({'state': 'gujarat'})
+        result = form.is_valid()
+        self.assertTrue(result)
\ No newline at end of file
Index: tests/regressiontests/localflavor/in_/forms.py
===================================================================
--- tests/regressiontests/localflavor/in_/forms.py	(revision 0)
+++ tests/regressiontests/localflavor/in_/forms.py	(revision 0)
@@ -0,0 +1,5 @@
+from django import forms
+from django.contrib.localflavor.in_.forms import INStateField
+
+class IndiaForm(forms.Form):
+    state = INStateField()
\ No newline at end of file
Index: tests/regressiontests/localflavor/tests.py
===================================================================
--- tests/regressiontests/localflavor/tests.py	(revision 16025)
+++ tests/regressiontests/localflavor/tests.py	(working copy)
@@ -3,3 +3,4 @@
 
 # just import your tests here
 from us.tests import *
+from in_.tests import *
Index: django/contrib/localflavor/in_/in_states.py
===================================================================
--- django/contrib/localflavor/in_/in_states.py	(revision 16025)
+++ django/contrib/localflavor/in_/in_states.py	(working copy)
@@ -47,38 +47,88 @@
 )
 
 STATES_NORMALIZED = {
-    'ka': 'KA',
-    'karnatka': 'KA',
-    'tn': 'TN',
-    'tamilnad': 'TN',
-    'tamilnadu': 'TN',
+    'an': 'AN',
+    'andaman and nicobar': 'AN',
     'andra pradesh': 'AP',
     'andrapradesh': 'AP',
     'andhrapradesh': 'AP',
-    'maharastra': 'MH',
-    'mh': 'MH',
     'ap': 'AP',
+    'andhra pradesh': 'AP',
+    'ar': 'AR',
+    'arunachal pradesh': 'AR',
+    'assam': 'AS',
+    'as': 'AS',
+    'bihar': 'BR',
+    'br': 'BR',
+    'cg': 'CG',
+    'chattisgarh': 'CG',
+    'ch': 'CH',
+    'chandigarh': 'CH',
+    'daman and diu': 'DD',
+    'dd': 'DD',
     'dl': 'DL',
-    'dd': 'DD',
-    'br': 'BR',
-    'ar': 'AR',
-    'sk': 'SK',
-    'kl': 'KL',
+    'delhi': 'DL',
+    'dn': 'DN',
+    'dadra and nagar haveli': 'DN',
     'ga': 'GA',
-    'rj': 'RJ',
-    'rajastan': 'RJ',
-    'rajasthan': 'RJ',
+    'goa': 'GA',
+    'gj': 'GJ',
+    'gujarat': 'GJ',
+    'himachal pradesh': 'HP',
     'hp': 'HP',
-    'ua': 'UA',
-    'up': 'UP',
+    'hr': 'HR',
+    'haryana': 'HR',
+    'jharkhand': 'JH',
+    'jh': 'JH',
+    'jammu and kashmir': 'JK',
+    'jk': 'JK',
+    'karnataka': 'KA',
+    'karnatka': 'KA',
+    'ka': 'KA',
+    'kerala': 'KL',
+    'kl': 'KL',
+    'ld': 'LD',
+    'lakshadweep': 'LD',
+    'maharastra': 'MH',
+    'mh': 'MH',
+    'maharashtra': 'MH',
+    'meghalaya': 'ML',
+    'ml': 'ML',
+    'mn': 'MN',
+    'manipur': 'MN',
+    'madhya pradesh': 'MP',
     'mp': 'MP',
+    'mizoram': 'MZ',
+    'mizo': 'MZ',
     'mz': 'MZ',
-    'bengal': 'WB',
-    'westbengal': 'WB',
-    'mizo': 'MZ',
+    'nl': 'NL',
+    'nagaland': 'NL',
+    'orissa': 'OR',
+    'odisa': 'OR',
     'orisa': 'OR',
-    'odisa': 'OR',
     'or': 'OR',
-    'ar': 'AR',
+    'pb': 'PB',
+    'punjab': 'PB',
+    'py': 'PY',
+    'pondicherry': 'PY',
+    'rajasthan': 'RJ',
+    'rajastan': 'RJ',
+    'rj': 'RJ',
+    'sikkim': 'SK',
+    'sk': 'SK',
+    'tamil nadu': 'TN',
+    'tn': 'TN',
+    'tamilnadu': 'TN',
+    'tamilnad': 'TN',
+    'tr': 'TR',
+    'tripura': 'TR',
+    'ua': 'UA',
+    'uttarakhand': 'UA',
+    'up': 'UP',
+    'uttar pradesh': 'UP',
+    'westbengal': 'WB',
+    'bengal': 'WB',
+    'wb': 'WB',
+    'west bengal': 'WB'
 }
 