diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/__init__.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/__init__.py
--- django/utils/unittest/__init__.py	2011-07-10 18:42:06.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/__init__.py	2010-07-12 23:04:10.000000000 +0200
@@ -26,19 +26,6 @@
 SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 """
 
-import sys
-
-# Django hackery to load the appropriate version of unittest
-
-try:
-    # check the system path first
-    from unittest2 import *
-except ImportError:
-    if sys.version_info >= (2,7):
-        # unittest2 features are native in Python 2.7
-        from unittest import *
-    else:
-        # otherwise use our bundled version
         __all__ = ['TestResult', 'TestCase', 'TestSuite',
                    'TextTestRunner', 'TestLoader', 'FunctionTestCase', 'main',
                    'defaultTestLoader', 'SkipTest', 'skip', 'skipIf', 'skipUnless',
@@ -50,23 +37,24 @@
         __all__.extend(['getTestCaseNames', 'makeSuite', 'findTestCases'])
 
 
-        from django.utils.unittest.collector import collector
-        from django.utils.unittest.result import TestResult
-        from django.utils.unittest.case import \
-            TestCase, FunctionTestCase, SkipTest, skip, skipIf,\
+from unittest2.collector import collector
+from unittest2.result import TestResult
+from unittest2.case import (
+    TestCase, FunctionTestCase, SkipTest, skip, skipIf,
             skipUnless, expectedFailure
-
-        from django.utils.unittest.suite import BaseTestSuite, TestSuite
-        from django.utils.unittest.loader import \
-            TestLoader, defaultTestLoader, makeSuite, getTestCaseNames,\
+)
+from unittest2.suite import BaseTestSuite, TestSuite
+from unittest2.loader import (
+    TestLoader, defaultTestLoader, makeSuite, getTestCaseNames,
             findTestCases
-
-        from django.utils.unittest.main import TestProgram, main, main_
-        from django.utils.unittest.runner import TextTestRunner, TextTestResult
+)
+from unittest2.main import TestProgram, main, main_
+from unittest2.runner import TextTestRunner, TextTestResult
 
         try:
-            from django.utils.unittest.signals import\
+    from unittest2.signals import (
                 installHandler, registerResult, removeResult, removeHandler
+    )
         except ImportError:
             # Compatibility with platforms that don't have the signal module
             pass
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/__main__.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/__main__.py
--- django/utils/unittest/__main__.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/__main__.py	2010-06-06 20:50:14.000000000 +0200
@@ -6,5 +6,5 @@
 
 __unittest = True
 
-from django.utils.unittest.main import main_
+from unittest2.main import main_
 main_()
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/case.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/case.py
--- django/utils/unittest/case.py	2011-07-10 20:15:49.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/case.py	2010-06-27 22:18:48.000000000 +0200
@@ -7,12 +7,13 @@
 import unittest
 import warnings
 
-from django.utils.unittest import result
-from django.utils.unittest.util import\
-    safe_repr, safe_str, strclass,\
+from unittest2 import result
+from unittest2.util import (
+    safe_repr, safe_str, strclass,
     unorderable_list_difference
+)
 
-from django.utils.unittest.compatibility import wraps
+from unittest2.compatibility import wraps
 
 __unittest = True
 
@@ -479,7 +480,7 @@
             excName = excClass.__name__
         else:
             excName = str(excClass)
-        raise self.failureException("%s not raised" % excName)
+        raise self.failureException, "%s not raised" % excName
 
     def _getAssertEqualityFunc(self, first, second):
         """Get a detailed comparison function for the types of the two args.
@@ -831,8 +832,8 @@
             self.fail(self._formatMessage(msg, standardMsg))
 
     def assertDictEqual(self, d1, d2, msg=None):
-        self.assertTrue(isinstance(d1, dict), 'First argument is not a dictionary')
-        self.assertTrue(isinstance(d2, dict), 'Second argument is not a dictionary')
+        self.assert_(isinstance(d1, dict), 'First argument is not a dictionary')
+        self.assert_(isinstance(d2, dict), 'Second argument is not a dictionary')
 
         if d1 != d2:
             standardMsg = '%s != %s' % (safe_repr(d1, True), safe_repr(d2, True))
@@ -909,9 +910,9 @@
 
     def assertMultiLineEqual(self, first, second, msg=None):
         """Assert that two multi-line strings are equal."""
-        self.assertTrue(isinstance(first, basestring), (
+        self.assert_(isinstance(first, basestring), (
                 'First argument is not a string'))
-        self.assertTrue(isinstance(second, basestring), (
+        self.assert_(isinstance(second, basestring), (
                 'Second argument is not a string'))
 
         if first != second:
@@ -997,7 +998,8 @@
                 excName = expected_exception.__name__
             else:
                 excName = str(expected_exception)
-            raise self.failureException("%s not raised" % excName)
+            raise self.failureException, "%s not raised" % excName
+
 
     def assertRegexpMatches(self, text, expected_regexp, msg=None):
         """Fail the test unless the text matches the regular expression."""
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/collector.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/collector.py
--- django/utils/unittest/collector.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/collector.py	2010-07-02 00:35:44.000000000 +0200
@@ -1,6 +1,6 @@
 import os
 import sys
-from django.utils.unittest.loader import defaultTestLoader
+from unittest2.loader import defaultTestLoader
 
 def collector():
     # import __main__ triggers code re-execution
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/loader.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/loader.py
--- django/utils/unittest/loader.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/loader.py	2010-06-10 21:06:58.000000000 +0200
@@ -9,12 +9,12 @@
 
 from fnmatch import fnmatch
 
-from django.utils.unittest import case, suite
+from unittest2 import case, suite
 
 try:
     from os.path import relpath
 except ImportError:
-    from django.utils.unittest.compatibility import relpath
+    from unittest2.compatibility import relpath
 
 __unittest = True
 
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/main.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/main.py
--- django/utils/unittest/main.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/main.py	2010-06-06 20:49:48.000000000 +0200
@@ -4,9 +4,9 @@
 import os
 import types
 
-from django.utils.unittest import loader, runner
+from unittest2 import loader, runner
 try:
-    from django.utils.unittest.signals import installHandler
+    from unittest2.signals import installHandler
 except ImportError:
     installHandler = None
 
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/result.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/result.py
--- django/utils/unittest/result.py	2011-07-10 20:15:49.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/result.py	2010-05-10 20:58:48.000000000 +0200
@@ -6,8 +6,8 @@
 
 from StringIO import StringIO
 
-from django.utils.unittest import util
-from django.utils.unittest.compatibility import wraps
+from unittest2 import util
+from unittest2.compatibility import wraps
 
 __unittest = True
 
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/runner.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/runner.py
--- django/utils/unittest/runner.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/runner.py	2010-05-10 20:58:48.000000000 +0200
@@ -4,10 +4,10 @@
 import time
 import unittest
 
-from django.utils.unittest import result
+from unittest2 import result
 
 try:
-    from django.utils.unittest.signals import registerResult
+    from unittest2.signals import registerResult
 except ImportError:
     def registerResult(_):
         pass
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/signals.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/signals.py
--- django/utils/unittest/signals.py	2011-07-10 20:15:49.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/signals.py	2010-04-08 06:04:52.000000000 +0200
@@ -1,7 +1,7 @@
 import signal
 import weakref
 
-from django.utils.unittest.compatibility import wraps
+from unittest2.compatibility import wraps
 
 __unittest = True
 
diff -u -Naur -x .svn -x .DS_Store -x test -x '*.pyc' -w django/utils/unittest/suite.py /Users/myk/Downloads/unittest2-0.5.1/unittest2/suite.py
--- django/utils/unittest/suite.py	2011-05-04 23:17:48.000000000 +0200
+++ /Users/myk/Downloads/unittest2-0.5.1/unittest2/suite.py	2010-06-11 16:30:56.000000000 +0200
@@ -2,7 +2,7 @@
 
 import sys
 import unittest
-from django.utils.unittest import case, util
+from unittest2 import case, util
 
 __unittest = True
 